import MockXMLHttpRequest from "./MockXMLHttpRequest";
import MockRequest from "./MockRequest";
import MockResponse from "./MockResponse";
export declare type MockCallback = (req?: MockRequest, res?: MockResponse) => MockResponse;
export declare class Builder {
    XMLHttpRequest: MockXMLHttpRequest;
    /** Replace the native XHR with the mocked XHR */
    setup(): Builder;
    /** Replace the mocked XHR with the native XHR and remove any handlers */
    teardown(): Builder;
    /** Remove any handlers */
    reset(): Builder;
    /** Mock a requests */
    mock(fn: (req?: MockRequest, res?: MockResponse) => MockResponse): Builder;
    mock(method: string, url?: string | RegExp, fn?: MockCallback): Builder;
    /** Mock a GET request */
    get(url: string | RegExp, fn: (req?: MockRequest, res?: MockResponse) => MockResponse): Builder;
    /** Mock a POST request */
    post(url: string | RegExp, fn: (req?: MockRequest, res?: MockResponse) => MockResponse): Builder;
    /** Mock a PUT request */
    put(url: string | RegExp, fn: (req?: MockRequest, res?: MockResponse) => MockResponse): Builder;
    /** Mock a PATCH request */
    patch(url: string | RegExp, fn: (req?: MockRequest, res?: MockResponse) => MockResponse): Builder;
    /** Mock a DELETE request */
    delete(url: string | RegExp, fn: (req?: MockRequest, res?: MockResponse) => MockResponse): Builder;
}
declare const _default: Builder;
export default _default;
