/** The mocked request data */
export default class MockRequest {
    private _xhr;
    private _method;
    private _url;
    private _body;
    private _headers;
    constructor(xhr: any);
    /** Get the HTTP method */
    method(): string;
    /** Get the HTTP URL */
    url(): string;
    /** Get the parsed URL query */
    query(): any;
    /** Get a HTTP Header */
    header(name: string): string;
    /** Set a HTTP Header */
    header(name: string, value: string): void;
    /** Set all of the HTTP headers */
    headers(headers: object): MockRequest;
    /** Get all of the HTTP headers */
    headers(): object;
    /** Get the HTTP body */
    body(): string;
    /** Set the HTTP body */
    body(body: string): MockRequest;
    /** Trigger progress event */
    progress(loaded: number, total?: number, lengthComputable?: boolean): void;
}
