/** The mocked response data */
export default class MockResponse {
    private _status;
    private _headers;
    private _body;
    private _timeout;
    constructor();
    /** Get the HTTP status */
    status(): number;
    /** Set the HTTP status */
    status(code: number): MockResponse;
    /** Get a HTTP header */
    header(name: string): string | undefined;
    /** Set a HTTP header */
    header(name: string, value: string): MockResponse;
    /** Get all of the HTTP headers */
    headers(): object;
    /** Set all of the HTTP headers */
    headers(headers: object): MockResponse;
    /** Get the HTTP body */
    body(): string;
    /** Set the HTTP body */
    body(body: string | object): MockResponse;
    /** Get the HTTP timeout */
    timeout(): number;
    /** Set the HTTP timeout */
    timeout(timeout: number | boolean): MockResponse;
}
