import MockResponse from "./MockResponse";
import MockRequest from "./MockRequest";
export default class MockXMLHttpRequest implements XMLHttpRequest {
    static readonly UNSENT: number;
    static readonly OPENED: number;
    static readonly HEADERS_RECEIVED: number;
    static readonly LOADING: number;
    static readonly DONE: number;
    static handlers: any[];
    /** Add a request handler */
    static addHandler(fn: (req: MockRequest, res: MockResponse) => any): void;
    /** Remove a request handler */
    static removeHandler(fn: (req: MockRequest, res: MockRequest) => any): MockXMLHttpRequest;
    /** Remove all request handlers */
    static reset(): void;
    /** Handle a request */
    static handle(req: MockRequest): MockResponse | null;
    readonly handlers: any[];
    readonly UNSENT: number;
    readonly OPENED: number;
    readonly HEADERS_RECEIVED: number;
    readonly LOADING: number;
    readonly DONE: number;
    withCredentials: boolean;
    status: number;
    statusText: string;
    method: string;
    url: string;
    user: string;
    password: string;
    data: string;
    async: boolean;
    reponse: string;
    responseText: string;
    responseType: XMLHttpRequestResponseType;
    responseXML: Document;
    responseURL: string;
    response: string;
    upload: XMLHttpRequestUpload;
    readyState: number;
    onreadystatechange: (this: XMLHttpRequest, ev: Event) => any;
    timeout: number;
    msCachingEnabled: () => boolean;
    onabort: (this: XMLHttpRequestEventTarget, ev: ProgressEvent) => any;
    onerror: (this: XMLHttpRequestEventTarget, ev: Event) => any;
    onload: (this: XMLHttpRequestEventTarget, ev: ProgressEvent) => any;
    onloadend: (this: XMLHttpRequestEventTarget, ev: ProgressEvent) => any;
    onloadstart: (this: XMLHttpRequestEventTarget, ev: ProgressEvent) => any;
    onprogress: (this: XMLHttpRequestEventTarget, ev: ProgressEvent) => any;
    ontimeout: (this: XMLHttpRequestEventTarget, ev: ProgressEvent) => any;
    private _events;
    private _sendTimeout;
    private _requestHeaders;
    private _responseHeaders;
    constructor();
    dispatchEvent(evt: Event): boolean;
    /** Reset the response values */
    reset(): void;
    /** Trigger an event */
    trigger(type: string, options?: any): MockXMLHttpRequest;
    open(method: string, url?: string, async?: boolean, user?: string, password?: string): void;
    setRequestHeader(name: string, value: string): void;
    overrideMimeType(mime: string): void;
    send(data?: any): void;
    abort(): void;
    getAllResponseHeaders(): null | string;
    getResponseHeader(name: string): null | string;
    addEventListener<K extends keyof XMLHttpRequestEventTargetEventMap>(type: K, listener: (event?: XMLHttpRequestEventTargetEventMap[K]) => any, useCapture?: boolean): void;
    removeEventListener<K extends keyof XMLHttpRequestEventMap>(type: K, listener: (event?: XMLHttpRequestEventMap[K]) => any): void;
}
